<?php
namespace App\Factory;

use Doctrine\DBAL\Connection;

class Dashboard {
    private $connection;

    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }

    public function dashboard($dtInicAberMesa, $dtFimAberMesa) 
    {
		$sql = "
			SELECT
				NVL(C.IDORGCMDVENDA, 'DLV_OUT') AS IDORGCMDVENDA,
				(
                    CASE TO_CHAR(C.IDRETBALLOJA) 
					WHEN 'S' THEN 'RETIRAR NO BALCÃO'
					WHEN 'N' THEN 'DELIVERY'
					WHEN 'C' THEN 'CONSUMO NO LOCAL'
					ELSE 'OUTROS' END
                ) AS TOGO,
				(IT.VRTOTAL + C.VRACRCOMANDA) VRPEDIDO,
				TO_CHAR(V.DTHRABERMESA, 'DD/MM/YYYY HH24:MI:SS') AS DTHRABERMESA,
				C.IDSTCOMANDA	
			FROM 
                VENDAREST V
				JOIN COMANDAVEN C ON ( V.CDFILIAL = C.CDFILIAL AND V.NRVENDAREST = C.NRVENDAREST )
                JOIN LOJA L ON ( L.CDFILIAL = C.CDFILIAL AND L.CDLOJA = C.CDLOJA )
				JOIN 
                (
                    SELECT 
                        CDFILIAL, 
                        NRCOMANDA, 
					    NRVENDAREST, 
                        SUM((QTPRODCOMVEN*VRPRECCOMVEN) - VRDESCCOMVEN + VRACRCOMVEN) AS VRTOTAL,
                        SUM(QTPRODCOMVEN*VRPRECCOMVEN) AS VRTOTALPRODUTOS, SUM(VRDESCCOMVEN) AS VRDESCOMANDA,
                        SUM(QTPRODCOMVEN) AS QTDPROD
		 		    FROM 
                        ITCOMANDAVEN
	 				GROUP BY 
                        CDFILIAL, 
                        NRCOMANDA, 
                        NRVENDAREST
                ) IT ON ( IT.CDFILIAL = C.CDFILIAL AND IT.NRVENDAREST = C.NRVENDAREST AND IT.NRCOMANDA = C.NRCOMANDA )
			WHERE 
                V.DTHRABERMESA BETWEEN (TO_DATE(:DTINICABERMESA, 'DD/MM/YYYY HH24:MI:SS')) AND (TO_DATE(:DTFIMABERMESA, 'DD/MM/YYYY HH24:MI:SS'))
			ORDER BY 
                V.DTHRABERMESA DESC
		";
        
		$stmt = $this->connection->prepare($sql);
		$stmt->bindValue("DTINICABERMESA", $dtInicAberMesa);
		$stmt->bindValue("DTFIMABERMESA", $dtFimAberMesa);
		$result = $stmt->executeQuery();
		
		return $result->fetchAllAssociative();
	}
}